;init system
;ONLY TWO STATE!:sound/nosound
;ff padding/no phase reset/no hum
;e0 speed counter
;e1 pulse strum1
;e2 pulse strum2
;e3 noise strum3
;e4 e5 e6 e7 e8 e9 ea eb ec ed ee apu reg data
;ef track speed
;f0 f1 track pointer
;f2 f3 current freq pointer
;f4 f5 freq data
;f6 f7 freq shift
;f8 f9 apu reg unused
;fa fb track start
;fc fd=track end
audioinit:
;sei
;cld
;ldx #$00
lda #$0f
sta $4015
;format compare ram
lda #$d0
sta $00
lda #$00
sta $01
formatting:
lda #$aa
sta ($00,x)
inc $00
lda $00
cmp #$e0
bne formatting
lda $c4
sta $f0
sta $fa
lda $c5
sta $f1
sta $fb
lda $c6
sta $fc
lda $c7
sta $fd
lda $fff4
sta $ef
sta $e0
dec $e0
lda $fff5
and #$c0
sta $e1
lda $fff6
and #$c0
sta $e2
lda $fff7
and #$80
sta $e3
;lda #$80
;sta $2000
rts
;loopy:
;jmp loopy
audioplayer:
;sta $fe
inc $e0
lda $e0
cmp $ef
beq tracker
;lda $fe
rts
tracker:
lda #$00
sta $e0
;compute pulse1
lda ($f0,x)
and #$3f
sta $f2
lda #$a7
sta $f3
lda ($f2,x)
eor #$ff ;test table
sta $e6
lda ($f0,x)
and #$3f
ora #$40
sta $f2
lda ($f2,x)
eor #$ff ;test table
and #$07
ora #$80
sta $e7
lda ($f0,x)
and #$40
beq mute1
lda #$38
jmp mute2
mute1:
lda #$30
mute2:
ora $e1
sta $e4
lda #$08
sta $e5
jsr advance
;compute pulse2
lda ($f0,x)
and #$3f
sta $f2
lda #$a7
sta $f3
lda ($f2,x)
eor #$ff ;test table
sta $ea
lda ($f0,x)
and #$3f
ora #$40
sta $f2
lda ($f2,x)
eor #$ff ;test table
and #$07
ora #$80
sta $eb
lda ($f0,x)
and #$40
beq mute3
lda #$38
jmp mute4
mute3:
lda #$30
mute4:
ora $e2
sta $e8
lda #$08
sta $e9
jsr advance
;commutate triangle
lda ($f0,x)
and #$3f
sta $f2
lda #$a7
sta $f3
lda ($f2,x)
eor #$ff ;test table
sta $f6
lda ($f0,x)
and #$3f
ora #$40
sta $f2
lda ($f2,x)
eor #$ff ;test table
sta $f7
lda ($f0,x)
and #$40
beq mute5
lda #$88
jmp mute6
mute5:
lda #$80
mute6:
sta $ec
ror $f7
ror $f6
lda $f6
and #$ff
sta $ed
lda $f7
and #$03
ora #$80
sta $ee
jsr advance
;commutate noise
lda ($f0,x)
and #$0f
ora $e3
sta $f9
lda ($f0,x)
and #$40
beq mute7
lda #$38
jmp mute8
mute7:
lda #$30
mute8:
sta $f8
jsr advance
;trasfer to regs
lda $e4
cmp $d4
beq trasf1
sta $d4
sta $4000
trasf1:
lda $e5
cmp $d5
beq trasf2
sta $d5
sta $4001
trasf2:
lda $e6
cmp $d6
beq trasf3
sta $d6
sta $4002
trasf3:
lda $e7
cmp $d7
beq trasf4
sta $d7
sta $4003
trasf4:
lda $e8
cmp $d8
beq trasf5
sta $d8
sta $4004
trasf5:
lda $e9
cmp $d9
beq trasf6
sta $d9
sta $4005
trasf6:
lda $ea
cmp $da
beq trasf7
sta $da
sta $4006
trasf7:
lda $eb
cmp $db
beq trasf8
sta $db
sta $4007
trasf8:
lda $ec
cmp $dc
beq trasf9
sta $dc
sta $4008
trasf9:
lda $ed
cmp $dd
beq trasfa
sta $dd
sta $400a
trasfa:
lda $ee
;cmp $de
;beq trasfb
;sta $de
sta $400b
;trasfb:
lda $f8
cmp $df
beq trasfc
sta $df
sta $400c
trasfc:
lda $f9
cmp $de
beq trasfd
sta $de
sta $400e
trasfd:
lda #$80
sta $400f
sta $4017
;lda $fe
rts
advance:
inc $f0
bne advance1
inc $f1
advance1:
lda $f0
cmp $fc
bne advance2
lda $f1
cmp $fd
bne advance2
lda $fa
sta $f0
lda $fb
sta $f1
advance2:
rts
.org $4000
.byt $f1,$7f,$13,$ad,$4d,$f3,$9d,$4c,$00,$b8,$74,$34
.byt $f8,$bf,$89,$56,$26,$f9,$ce,$a6,$80,$5c,$3a,$1a
.byt $fb,$df,$c4,$ab,$93,$7c,$67,$52,$3f,$2d,$1c,$0c
.byt $fd,$ef,$e1,$d5,$c9,$bd,$b3,$a9,$9f,$96,$8e,$86
.byt $7e,$77,$70,$6a,$64,$5e,$59,$54,$4f,$4b,$46,$42
.byt $3f,$3b,$38,$34,$31,$2f,$2c,$29,$27,$25,$23,$21
.byt $1f,$1d,$1b,$1a,$18,$17,$15,$14
.org $4000
.byt $07,$07,$07,$06,$06,$05,$05,$05,$05,$04,$04,$04
.byt $03,$03,$03,$03,$03,$02,$02,$02,$02,$02,$02,$02
.byt $01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01,$01
.byt $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.byt $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.byt $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
.byt $00,$00,$00,$00,$00,$00,$00,$00
.org $fff4
.byt $08
.byt $00
.byt $00
.byt $80
